/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.51 Revision 1.66
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.51 2007/10/08 14:58:14 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.66 2009/02/23 23:46:31 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 77
78 >=app-admin/eselect-vdr-0.0.2 78DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80 80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
81 82
82# New method of storing plugindb 83# New method of storing plugindb
83# Called from src_install 84# Called from src_install
84# file maintained by normal portage-methods 85# file maintained by normal portage-methods
85create_plugindb_file() { 86create_plugindb_file() {
86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 87 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}" 88 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
88 insinto "${NEW_VDRPLUGINDB_DIR}" 89 insinto "${NEW_VDRPLUGINDB_DIR}"
90
91# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
89 cat <<-EOT > "${D}/${DB_FILE}" 92# cat <<-EOT > "${D}/${DB_FILE}"
90 VDRPLUGIN_DB=1 93# VDRPLUGIN_DB=1
91 CREATOR=ECLASS 94# CREATOR=ECLASS
92 EBUILD=${CATEGORY}/${PN} 95# EBUILD=${CATEGORY}/${PN}
93 EBUILD_V=${PVR} 96# EBUILD_V=${PVR}
94 EOT 97# EOT
98 {
99 echo "VDRPLUGIN_DB=1"
100 echo "CREATOR=ECLASS"
101 echo "EBUILD=${CATEGORY}/${PN}"
102 echo "EBUILD_V=${PVR}"
103 echo "PLUGINS=\"$@\""
104 } > "${D}/${DB_FILE}"
95} 105}
96 106
97# Delete files created outside of vdr-plugin.eclass 107# Delete files created outside of vdr-plugin.eclass
98# vdrplugin-rebuild.ebuild converted plugindb and files are 108# vdrplugin-rebuild.ebuild converted plugindb and files are
99# not deleted by portage itself - should only be needed as 109# not deleted by portage itself - should only be needed as
122create_header_checksum_file() 132create_header_checksum_file()
123{ 133{
124 # Danger: Not using $ROOT here, as compile will also not use it !!! 134 # Danger: Not using $ROOT here, as compile will also not use it !!!
125 # If vdr in $ROOT and / differ, plugins will not run anyway 135 # If vdr in $ROOT and / differ, plugins will not run anyway
126 136
137 local CHKSUM="header-md5-vdr"
138
139 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
140 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
141 elif type -p md5sum >/dev/null 2>&1; then
142 (
143 cd "${VDR_INCLUDE_DIR}"
144 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
145 ) > "${CHKSUM}"
146 else
147 die "Could not create md5 checksum of headers"
148 fi
149
127 insinto "${VDR_CHECKSUM_DIR}" 150 insinto "${VDR_CHECKSUM_DIR}"
128 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 151 local p_name
129 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}" 152 for p_name; do
153 newins "${CHKSUM}" "header-md5-${p_name}"
154 done
155}
156
157fix_vdr_libsi_include()
158{
159 einfo "Fixing include of libsi-headers"
160 local f
161 for f; do
162 sed -i "${f}" \
163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
165 done
166}
167
168vdr_patchmakefile() {
169 einfo "Patching Makefile"
170 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
171 cp Makefile "${WORKDIR}"/Makefile.before
172
173 # plugin makefiles use VDRDIR in strange ways
174 # assumptions:
175 # 1. $(VDRDIR) contains Make.config
176 # 2. $(VDRDIR) contains config.h
177 # 3. $(VDRDIR)/include/vdr contains the headers
178 # 4. $(VDRDIR) contains main vdr Makefile
179 # 5. $(VDRDIR)/locale exists
180 # 6. $(VDRDIR) allows to access vdr source files
181 #
182 # We only have one directory (for now /usr/include/vdr),
183 # that contains vdr-headers and Make.config.
184 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR)
188
189 ebegin " Setting paths"
190 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \
195 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::'
197 eend 0
198
199 # maybe needed for multiproto:
200 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
203
204 if ! grep -q APIVERSION Makefile; then
205 ebegin " Converting to APIVERSION"
206 sed -i Makefile \
207 -e 's:^APIVERSION = :APIVERSION ?= :' \
208 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
209 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
210 eend $?
211 fi
212
213 # Correcting Compile-Flags
214 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
215 sed -i Makefile \
216 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
217 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
218
219 # Disabling file stripping, useful for debugging
220 sed -i Makefile \
221 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d'
224
225 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228}
229
230vdr_add_local_patch() {
231 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
232 echo
233 einfo "Applying local patches"
234 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
235 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
236 done
237 fi
238}
239
240vdr_has_gettext() {
241 has_version ">=media-video/vdr-1.5.7"
242}
243
244plugin_has_gettext() {
245 [[ -d po ]]
246}
247
248vdr_i18n_convert_to_gettext() {
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
250
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild"
253 return 1
254 fi
255
256 if [[ ! -x ${i18n_tool} ]]; then
257 eerror "Missing ${i18n_tool}"
258 eerror "Please re-emerge vdr"
259 die "Missing ${i18n_tool}"
260 fi
261
262 ebegin "Auto converting translations to gettext"
263 # call i18n-to-gettext tool
264 # take all texts missing tr call into special file
265 "${i18n_tool}" 2>/dev/null \
266 |sed -e '/^"/!d' \
267 -e '/^""$/d' \
268 -e 's/\(.*\)/trNOOP(\1)/' \
269 > dummy-translations-trNOOP.c
270
271 # if there were untranslated texts just run it again
272 # now the missing calls are listed in
273 # dummy-translations-trNOOP.c
274 if [[ -s dummy-translations-trNOOP.c ]]; then
275 "${i18n_tool}" &>/dev/null
276 fi
277
278 # now use the modified Makefile
279 if [[ -f Makefile.new ]]; then
280 mv Makefile.new Makefile
281 eend 0 ""
130 else 282 else
131 if type -p md5sum >/dev/null 2>&1; then 283 eend 1 "Conversion to gettext failed. Plugin needs fixing."
132 cd "${S}" 284 return 1
133 ( 285 fi
134 cd "${VDR_INCLUDE_DIR}" 286}
135 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 287
136 ) > header-md5-${PN} 288vdr_i18n_disable_gettext() {
137 doins header-md5-${PN} 289 ebegin "Disabling gettext support in plugin"
290 # Remove i18n Target if using older vdr
291 sed -i Makefile \
292 -e '/^all:/s/ i18n//'
293 eend 0
294}
295
296vdr_i18n() {
297 if vdr_has_gettext; then
298 einfo "VDR has gettext support"
299 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK."
303 fi
304 else
305 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then
307 eerror ""
308 eerror "Plugin will have only english OSD texts"
309 eerror "it needs manual fixing."
310 fi
138 fi 311 fi
312 else
313 einfo "VDR has no gettext support"
314 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext
139 fi 316 fi
317 fi
140} 318}
319
320vdr-plugin_copy_source_tree() {
321 pushd . >/dev/null
322 cp -r "${S}" "${T}"/source-tree
323 cd "${T}"/source-tree
324 cp "${WORKDIR}"/Makefile.before Makefile
325 # TODO: Fix this, maybe no longer needed
326 sed -i Makefile \
327 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
328 -e 's:^CXXFLAGS:#CXXFLAGS:' \
329 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
330 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
331 popd >/dev/null
332}
333
334vdr-plugin_install_source_tree() {
335 einfo "Installing sources"
336 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
337 insinto "${destdir}-${PV}"
338 doins -r "${T}"/source-tree/*
339
340 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
341}
342
343vdr-plugin_print_enable_command() {
344 local p_name c=0 l=""
345 for p_name in ${vdr_plugin_list}; do
346 c=$(( c+1 ))
347 l="$l ${p_name#vdr-}"
348 done
349
350 elog
351 case $c in
352 1) elog "Installed plugin${l}" ;;
353 *) elog "Installed $c plugins:${l}" ;;
354 esac
355 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog
358}
359
360
361## exported functions
141 362
142vdr-plugin_pkg_setup() { 363vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others) 364 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC 365 append-flags -fPIC
145 366
153 374
154 # Pathes to includes 375 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr" 376 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include" 377 DVB_INCLUDE_DIR="/usr/include"
157 378
158
159 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
160 LOCDIR="/usr/share/vdr/locale" 380 LOCDIR="/usr/share/vdr/locale"
161 if has_version ">=media-video/vdr-1.5.7"; then
162 USE_GETTEXT=1
163 else
164 USE_GETTEXT=0
165 fi
166 381
167 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
168 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
169 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
170 385
171 einfo "Building ${PF} against vdr-${VDRVERSION}" 386 einfo "Compiling against"
172 einfo "APIVERSION: ${APIVERSION}" 387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
388}
389
390vdr-plugin_src_util() {
391
392 while [ "$1" ]; do
393
394 case "$1" in
395 all)
396 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
397 ;;
398 all_but_unpack)
399 vdr-plugin_src_util add_local_patch patchmakefile i18n
400 ;;
401 unpack)
402 base_src_unpack
403 ;;
404 add_local_patch)
405 cd "${S}" || die "Could not change to plugin-source-directory!"
406 vdr_add_local_patch
407 ;;
408 patchmakefile)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_patchmakefile
411 ;;
412 i18n)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_i18n
415 ;;
416 esac
417
418 shift
419 done
173} 420}
174 421
175vdr-plugin_src_unpack() { 422vdr-plugin_src_unpack() {
176 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 423 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
177 eerror "Wrong use of vdr-plugin.eclass." 424 eerror "Wrong use of vdr-plugin.eclass."
178 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 425 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
179 echo 426 echo
180 eerror "Please report this at bugs.gentoo.org." 427 eerror "Please report this at bugs.gentoo.org."
181 die "vdr-plugin_pkg_setup not called!" 428 die "vdr-plugin_pkg_setup not called!"
182 fi 429 fi
183 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 430 if [ -z "$1" ]; then
184 431 case "${EAPI:-0}" in
185 while [ "$1" ]; do 432 2)
186 433 vdr-plugin_src_util unpack
187 case "$1" in
188 all_but_unpack)
189 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
190 ;; 434 ;;
191 unpack) 435 *)
192 base_src_unpack 436 vdr-plugin_src_util all
193 ;; 437 ;;
194 patchmakefile)
195 if ! cd "${S}"; then
196 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
197 ewarn "Perhaps you find one among these:"
198 cd "${WORKDIR}"
199 ewarn "$(/bin/ls -1 "${WORKDIR}")"
200 die "Could not change to plugin-source-directory!"
201 fi
202
203 einfo "Patching Makefile"
204 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
205 cp Makefile "${WORKDIR}"/Makefile.before
206
207 sed -i Makefile \
208 -e '1i\#Makefile was patched by vdr-plugin.eclass'
209
210 ebegin " Setting Pathes"
211 sed -i Makefile \
212 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
213 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
214 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
215 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
216 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
217 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
218 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
219 eend $?
220
221 ebegin " Converting to APIVERSION"
222 sed -i Makefile \
223 -e 's:^APIVERSION = :APIVERSION ?= :' \
224 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
225 -e '2i\APIVERSION = '"${APIVERSION}"
226 eend $?
227
228 ebegin " Correcting Compile-Flags"
229 sed -i Makefile \
230 -e 's:^CXXFLAGS:#CXXFLAGS:' \
231 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
232 eend $?
233
234 ebegin " Disabling file stripping"
235 sed -i Makefile \
236 -e '/@.*strip/d' \
237 -e '/strip \$(LIBDIR)\/\$@/d' \
238 -e '/^STRIP =/d' \
239 -e '/@.*\$(STRIP)/d'
240 eend $?
241
242 # Use a file instead of an variable as single-stepping via ebuild
243 # destroys environment.
244 touch ${WORKDIR}/.vdr-plugin_makefile_patched
245 ;;
246 add_local_patch)
247 cd "${S}"
248 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
249 echo
250 einfo "Applying local patches"
251 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
252 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
253 done
254 fi
255 ;;
256 i18n)
257 cd "${S}"
258 if [[ ${USE_GETTEXT} = 0 ]]; then
259 # Remove i18n Target if using older vdr
260 sed -i Makefile \
261 -e '/^all:/s/ i18n//'
262 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
263 einfo "Converting translations to gettext"
264
265 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
266 if [[ ! -x ${i18n_tool} ]]; then
267 eerror "Missing ${i18n_tool}"
268 eerror "Please re-emerge vdr"
269 die "Missing ${i18n_tool}"
270 fi
271
272 # call i18n-to-gettext tool
273 # take all texts missing tr call into special file
274 "${i18n_tool}" 2>/dev/null \
275 |sed -e '/^"/!d' \
276 -e '/^""$/d' \
277 -e 's/\(.*\)/trNOOP(\1)/' \
278 > dummy-translations-trNOOP.c
279
280 # if there were untranslated texts just run it again
281 # now the missing calls are listed in
282 # dummy-translations-trNOOP.c
283 if [[ -s dummy-translations-trNOOP.c ]]; then
284 "${i18n_tool}" &>/dev/null
285 fi
286
287 # now use the modified Makefile
288 mv Makefile.new Makefile
289 fi
290 esac 438 esac
291 439
292 shift 440 else
293 done 441 vdr-plugin_src_util $@
442 fi
294} 443}
295 444
296vdr-plugin_copy_source_tree() { 445vdr-plugin_src_prepare() {
297 pushd . >/dev/null 446 vdr-plugin_src_util all_but_unpack
298 cp -r "${S}" "${T}"/source-tree
299 cd "${T}"/source-tree
300 cp "${WORKDIR}"/Makefile.before Makefile
301 sed -i Makefile \
302 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
303 -e 's:^CXXFLAGS:#CXXFLAGS:' \
304 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
305 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
306 popd >/dev/null
307}
308
309vdr-plugin_install_source_tree() {
310 einfo "Installing sources"
311 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
312 insinto "${destdir}-${PV}"
313 doins -r "${T}"/source-tree/*
314
315 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
316} 447}
317 448
318vdr-plugin_src_compile() { 449vdr-plugin_src_compile() {
319 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 450 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
320 451
333 eerror "Please report this at bugs.gentoo.org." 464 eerror "Please report this at bugs.gentoo.org."
334 die "vdr-plugin_src_unpack not called!" 465 die "vdr-plugin_src_unpack not called!"
335 fi 466 fi
336 cd "${S}" 467 cd "${S}"
337 468
469 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
470
338 emake ${BUILD_PARAMS} \ 471 emake ${BUILD_PARAMS} \
339 ${VDRPLUGIN_MAKE_TARGET:-all} \ 472 ${BUILD_TARGETS} \
340 LOCALEDIR="${TMP_LOCALE_DIR}" \ 473 LOCALEDIR="${TMP_LOCALE_DIR}" \
474 LIBDIR="${S}" \
475 TMPDIR="${T}" \
341 || die "emake failed" 476 || die "emake failed"
342 ;; 477 ;;
343 esac 478 esac
344 479
345 shift 480 shift
366 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 501 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
367 doins "${mname}.patched" 502 doins "${mname}.patched"
368 503
369 fi 504 fi
370 505
506
507
371 cd "${S}" 508 cd "${S}"
372 insinto "${VDR_PLUGIN_DIR}" 509 insinto "${VDR_PLUGIN_DIR}"
373 doins libvdr-*.so.* 510 doins libvdr-*.so.*
374 511
375 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 512 # create list of all created plugin libs
513 vdr_plugin_list=""
514 local p_name
515 for p in libvdr-*.so.*; do
516 p_name="${p%.so*}"
517 p_name="${p_name#lib}"
518 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
519 done
520
521 create_header_checksum_file ${vdr_plugin_list}
522 create_plugindb_file ${vdr_plugin_list}
523
524 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
376 einfo "Installing locales" 525 einfo "Installing locales"
377 cd "${TMP_LOCALE_DIR}" 526 cd "${TMP_LOCALE_DIR}"
378 insinto "${LOCDIR}" 527 insinto "${LOCDIR}"
379 doins -r * 528 doins -r *
380 fi 529 fi
398 547
399 if [[ -n ${VDR_RCADDON_FILE} ]]; then 548 if [[ -n ${VDR_RCADDON_FILE} ]]; then
400 insinto "${VDR_RC_DIR}" 549 insinto "${VDR_RC_DIR}"
401 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 550 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
402 fi 551 fi
403
404 create_header_checksum_file
405 create_plugindb_file
406}
407
408vdr-plugin_print_enable_command() {
409 ewarn "emerge --config ${PN} is deprecated"
410 elog
411 elog "To activate this vdr-plugin execute the following command:"
412 elog "\teselect vdr-plugin enable ${PN#vdr-}"
413 elog
414} 552}
415 553
416vdr-plugin_pkg_postinst() { 554vdr-plugin_pkg_postinst() {
417 vdr-plugin_print_enable_command 555 vdr-plugin_print_enable_command
418 556
425 563
426vdr-plugin_pkg_postrm() { 564vdr-plugin_pkg_postrm() {
427 delete_orphan_plugindb_file 565 delete_orphan_plugindb_file
428} 566}
429 567
430vdr-plugin_pkg_config_legacy() {
431 elog "Using old interface to gentoo-vdr-scripts-0.3.7"
432 if [[ -z "${INSTALLPLUGIN}" ]]; then
433 INSTALLPLUGIN="${VDRPLUGIN}"
434 fi
435
436 active=0
437 # First test if plugin is already inside PLUGINS
438 local conf=/etc/conf.d/vdr.plugins
439 exec 3<${conf}
440 while read -u 3 line; do
441 [[ ${line} == "" ]] && continue
442 [[ ${line:0:1} == "#" ]] && continue
443 set -- ${line}
444 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
445 done
446 exec 3<&-
447
448 if [[ $active == 0 ]]; then
449 elog "Adding ${INSTALLPLUGIN} to active plugins."
450
451 # The pure edit process.
452 echo "${INSTALLPLUGIN}" >> "${conf}"
453 else
454 elog "${INSTALLPLUGIN} already activated"
455 echo
456 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
457 if [[ "${answer}" != "yes" ]]; then
458 elog "aborted"
459 return
460 fi
461 elog "Removing ${INSTALLPLUGIN} from active plugins."
462
463 # The pure edit process
464 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
465 fi
466}
467
468vdr-plugin_pkg_config() { 568vdr-plugin_pkg_config() {
569 ewarn "emerge --config ${PN} is no longer supported"
469 vdr-plugin_print_enable_command 570 vdr-plugin_print_enable_command
470
471 einfo "Calling this now"
472 eselect vdr-plugin enable "${PN#vdr-}"
473} 571}
474 572
475fix_vdr_libsi_include() 573case "${EAPI:-0}" in
476{ 574 2)
477 einfo "Fixing include of libsi-headers" 575 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
478 local f 576 ;;
479 for f; do 577 *)
480 sed -i "${f}" \
481 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
482 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
483 done
484}
485
486EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 578 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
579 ;;
580esac

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.66

  ViewVC Help
Powered by ViewVC 1.1.20